<?php
// SHORCODE TO DISPLAY SWIFT NEWS

// [swiftbox] 
function nb_shortcode($atts, $content = null) {
	include_once(NB_DIR . '/functions.php');
	
	extract( shortcode_atts( array(
		'id' => ''
	), $atts ) );
	if(empty($id)) {return '';}
	
	
	// get newsbox data
	$box = get_term($id, 'nb_boxes');
	$data = (empty($box->description)) ? '' : $box->description;	
	
	if(empty($data)) {return '';}
	
	
	$data = unserialize(nb_fix_serialization($data));
	
	// v1.30 - added json_encode - process it
	if($data && !is_array($data)) {
		$data = json_decode(base64_decode($data), true);
	}
	
	// still no array - stop here
	if(!is_array($data)) {
		return false;
	}
	
	
	$opt = $data['settings'];
	
	// remote sources
	$rm_src = array();
	foreach($data['src'] as $src) {
		if($src['src_type'] != 'wp_cat' && $src['src_type'] != 'qn_cat' && $src['src_type'] != 'woo_cat' && strpos($src['src_type'], '|||') === false) {
			$rm_src[] = $src;	
		}
	}
	
	
	/************************/
	
	
	// wrapper
	$nb = '<div id="lcnb_'.$id.'" class="lcnb_wp_wrap">%INLINE%</div>';
	
	// check if inline news are needed
	if(count($rm_src) != count($data['src'])) {
		
		$inl_code = '';
		foreach($data['src'] as $src) {
			if($src['src_type'] == 'wp_cat' || $src['src_type'] == 'qn_cat' || $src['src_type'] == 'woo_cat' || strpos($src['src_type'], '|||') !== false) {
				$inl_code .= nb_inline_code($src, $opt['max_news'], $opt['manage_exp_images']);		
			}
		}
		$nb = str_replace('%INLINE%', $inl_code, $nb);
	}
	else {$nb = str_replace('%INLINE%', '', $nb);}
	
	
	//// javascript
	$nb .= '
	<script type="text/javascript">
	jQuery(document).ready(function($) {
		
		var box_opts = {
	';
		// SOURCES
		if(count($rm_src) > 0) {
			$nb .= 'src:[';

			$sc = 1;
			foreach($rm_src as $src) {			
				$nb .= '{';
				
				// image size check
				if(get_option('nb_img_check')) {
					$nb .= 'max_img_size:{w : '.get_option('nb_max_img_w', 800).', h : '.get_option('nb_max_img_h', 600).'},
		';	
				}
				
				// expanded images management
				$nb .= 'exp_img_manag:{pos : "'.$src['exp_img_pos'].'", w : "'.$src['exp_img_w'].'", h : "'.$src['exp_img_h'].'"},
		'; 
				
				$a = 1;
				foreach($src as $i=>$v) {
				
					if(!in_array($i, array('src_val', 'exp_img_pos', 'exp_img_w', 'exp_img_h', 'news_offset'))) {
						if($i == 'src_type') {
							$nb .= 'type:"'.$v.'",';
							$nb .= nb_src_opt_index($v) .': "'. $src['src_val'] .'",
		';	
						}
						else {
							if($i == 'src_hide_elements') {
								$i = 'hide_elements';
							} else if($i == 'author') {
								$v = str_replace(array('&apos;', '&quot;', '&lt;', '&gt;'), array('\'', '"', '<', '>'), $v);
							}	
							$ending_comma = ($a == count($src)) ? '
	' : ',
	';
							$val = nb_php_to_js_datatype($i, $v);
							$nb .= $i.' : '.$val.$ending_comma;
						}		
					}
					
					$a++;
				}
				
				$src_comma = ($sc == count($rm_src)) ? '
	' : ',
	';
				$nb .= '}'.$src_comma;
				$sc++;
			}
			
			$nb .= '],
	';
		}

	
		// OPTIONS
		$b = 1;
		foreach ($opt as $i=>$v) {
			if($i != 'box_id') {
				$ending_comma = ($b == count($opt)) ? '
	' : ',
	';
				$val = nb_php_to_js_datatype($i, $v);
				$nb .= $i.' : '.$val.$ending_comma;
				
				// if hide elements - check for socials
				if($i == 'hide_elements' && is_array($v) && in_array('socials', $v)) {
					$nb .= 'social_share : false,';
				}
			}
			$b++;
		}
	
	$nb .= '
		}; 
		
		$.extend(box_opts, lcnb_glob_vars);
		$("#lcnb_'.$id.'").lc_swift_box(box_opts);
	});
	</script>';


	return str_replace(array("\r", "\n", "\t", "\v"), '', $nb);
}
add_shortcode('swiftbox', 'nb_shortcode');
add_shortcode('newsbox', 'nb_shortcode');