<?php
/* 
Plugin Name: Swift Box
Plugin URI: https://lcweb.it/swift-box-wordpress-plugin
Description: Display contents from different sources in an unique, responsive, environment. Create your own style and customize every single aspect of the box.
Author: 20script
Version: 2.01
Author URI: http://www.20script.ir
*/  


/////////////////////////////////////////////
/////// MAIN DEFINES ////////////////////////
/////////////////////////////////////////////

// plugin path
$wp_plugin_dir = substr(plugin_dir_path(__FILE__), 0, -1);
define( 'NB_DIR', $wp_plugin_dir);

// plugin url
$wp_plugin_url = substr(plugin_dir_url(__FILE__), 0, -1);
define( 'NB_URL', $wp_plugin_url);

define('NB_VER', 2.01);
define('NB_JS_VER', 2.01);



/////////////////////////////////////////////
/////// FORCING DEBUG ///////////////////////
/////////////////////////////////////////////

if(isset($_REQUEST['lcwp_debug'])) {
	ini_set('display_errors', 1);
	ini_set('display_startup_errors', 1);
	error_reporting(E_ALL);	
}



/////////////////////////////////////////////
/////// MULTILANGUAGE SUPPORT ///////////////
/////////////////////////////////////////////

function nb_multilanguage() {
	$param_array = explode('/', NB_DIR);
 	$folder_name = end($param_array);
	
	load_plugin_textdomain('nb_ml', false, $folder_name .'/languages'); 
}
add_action('plugins_loaded', 'nb_multilanguage', 1);



/////////////////////////////////////////////
/////// MAIN SCRIPT & CSS INCLUDES //////////
/////////////////////////////////////////////


// global script enqueuing
function nb_global_scripts() {
	wp_enqueue_script('jquery');


	// admin
	if (is_admin()) {  
		wp_enqueue_style('nb_admin', NB_URL . '/css/admin.css', 999, NB_VER);
		wp_enqueue_style('nb_settings', NB_URL . '/settings/settings_style.css', 999, NB_VER);	
		
		// chosen
		wp_enqueue_style( 'lcwp-chosen-style', NB_URL.'/js/chosen/chosen.css', 999);
		
		// lcweb switch
		wp_enqueue_style( 'lc-switch', NB_URL.'/js/lc-switch/lc_switch.css', 999);
		
		// colorpicker
		wp_enqueue_style( 'nb-colpick', NB_URL.'/js/colpick/css/colpick.css', 999);
		
		wp_enqueue_script('jquery-ui-slider');
	}
	
	
	// frontend
	if (!is_admin()) {
		$in_footer = (get_option('nb_js_head') != '1') ? true : false;

		// core scripts
		wp_enqueue_style('nb-core',  NB_URL.'/js/sb/swift-box-layout.min.css', 900, NB_VER);
		wp_enqueue_script('nb-core', NB_URL.'/js/sb/swift-box.min.js', 100, NB_VER.'-'.NB_JS_VER, $in_footer);
		
		// theme
		if(!get_option('nb_inline_css') || !get_option('nb_custom_style')) {
			
			$theme = (get_option('nb_custom_style')) ? 'wpdt' : get_option('nb_main_style', 'minimal');
			wp_enqueue_style('nb-theme',  NB_URL.'/js/sb/themes/'. $theme .'.css', 900, NB_VER);
		}

		
		// Magnific Popup
		if(get_option('nb_lightbox', 1) || get_option('nb_exp_in_lb')) {
			wp_enqueue_style('nb-lightbox',  NB_URL.'/js/sb/js_assets/magnific-popup/magnific-popup-style.css', 900, NB_VER);
			wp_enqueue_script('nb-lightbox', NB_URL.'/js/sb/js_assets/magnific-popup/magnific-popup.min.js', 99, NB_VER, $in_footer);
		}
		
		// Touchswipe
		if(get_option('nb_touchswipe')) {
			wp_enqueue_script('nb-touchswipe', NB_URL.'/js/sb/js_assets/TouchSwipe/jquery.touchSwipe.min.js', 99, NB_VER, $in_footer);	
		}


		// frontend custom css inline - custom font sizes
		add_action('wp_head', 'nb_inline_css', 989);
	}
}
add_action('wp_enqueue_scripts', 'nb_global_scripts', 900);
add_action('admin_enqueue_scripts', 'nb_global_scripts');



// USE FRONTEND CSS INLINE
function nb_inline_css(){
	$typography_css 	= '';
	$title_font_family 	= get_option('nb_title_font_family');
	$txt_font_family 	= get_option('nb_txt_font_family');
	
	
	// font family 
	if(!empty($title_font_family)) {
		$typography_css .= '.lcnb_title {font-family: '. $title_font_family .';}';	
	}
	if(!empty($txt_font_family)) {
		$typography_css .= '.lcnb_txt, .lcnb_exp_txt > *:not(.lcnb_title) {font-family: '. $txt_font_family .';}';	
	}
	
	// initial mode - desktop
	if((int)get_option('nb_is_title_size', 16) != 16) {
		$typography_css .= 
			'.lcnb_title {font-size: '.get_option('nb_is_title_size', 16).'px; line-height: '. ((int)get_option('nb_is_title_size', 16) + 6) .'px;} ';
	}
	if((int)get_option('nb_is_txt_size', 14) != 14) {
		$typography_css .= 
			'.lcnb_txt {font-size: '.get_option('nb_is_txt_size', 14).'px; line-height: '. ((int)get_option('nb_is_txt_size', 14) + 6) .'px;} ';
	}
	
	// initial mode - mobile
	if((int)get_option('nb_ism_title_size', 14) != 14) {
		$typography_css .= 
			'@media screen and (max-width:960px) { 
				.lcnb_title {font-size: '.get_option('nb_ism_title_size', 14).'px; line-height: '. ((int)get_option('nb_ism_title_size', 14) + 6) .'px;}
			}';
	}
	if((int)get_option('nb_ism_txt_size', 12) != 12) {
		$typography_css .= 
			'@media screen and (max-width:960px) { 
				.lcnb_title {font-size: '.get_option('nb_ism_txt_size', 12).'px; line-height: '. ((int)get_option('nb_ism_txt_size', 12) + 6) .'px;}
			}';
	}
	
	// expanded mode - desktop
	if((int)get_option('nb_es_title_size', 21) != 21) {
		$typography_css .= 
			'.lcnb_exp_block .lcnb_title {font-size: '.get_option('nb_es_title_size', 21).'px; line-height: '. ((int)get_option('nb_es_title_size', 21) + 8) .'px;} ';
	}
	if((int)get_option('nb_es_txt_size', 14) != 14) {
		$typography_css .= 
			'.lcnb_exp_txt > *:not(.lcnb_title) {font-size: '.get_option('nb_es_txt_size', 14).'px; line-height: '. ((int)get_option('nb_es_txt_size', 14) + 7) .'px;} ';
	}
	
	// expanded mode - mobile
	if((int)get_option('nb_esm_title_size', 18) != 18) {
		$typography_css .= 
			'@media screen and (max-width:960px) { 
				.lcnb_exp_block .lcnb_title {font-size: '.get_option('nb_esm_title_size', 18).'px; line-height: '. ((int)get_option('nb_esm_title_size', 18) + 8) .'px;}
			}';
	}
	if((int)get_option('nb_esm_txt_size', 12) != 12) {
		$typography_css .= 
			'@media screen and (max-width:960px) { 
				.lcnb_exp_txt > *:not(.lcnb_title) {font-size: '.get_option('nb_esm_txt_size', 12).'px; line-height: '. ((int)get_option('nb_esm_txt_size', 12) + 7) .'px;}
			}';
	}
	
	
	
	// bad server - use custom theme inline
	if((get_option('nb_inline_css') || get_option('nb_force_inline_css')) && get_option('nb_custom_style')) {
		if(get_option('nb_inline_css') || get_option('nb_force_inline_css')) {
			echo '<style type="text/css">';
			include_once(NB_DIR . '/custom_theme_css.php');
			echo '</style>';		
		}
	}
	
	
	// custom CSS
	$custom_css = $typography_css . get_option('nb_custom_css');
	if(!empty($custom_css)) {echo '<style type="text/css">'.$custom_css.'</style>';}
}





/////////////////////////////////////////////
/////// MAIN INCLUDES ///////////////////////
/////////////////////////////////////////////

// admin menu and cpt and taxonomy
include_once(NB_DIR . '/admin_menu.php');

// quick news metaboxes
include_once(NB_DIR . '/metaboxes.php');

// Head JS vars
include_once(NB_DIR . '/head_js.php');

// shortcode
include_once(NB_DIR . '/shortcode.php');

// tinymce integration
include_once(NB_DIR . '/tinymce_implementation.php');

// ajax
include_once(NB_DIR . '/ajax.php');

// date placeholders helper
include_once(NB_DIR . '/date_format_helper.php');

// box preview
include_once(NB_DIR . '/nb_preview.php');



// visual composer integration
include_once(NB_DIR . '/builders_integration/visual_composer.php');

// cornerstone integration
include_once(NB_DIR . '/builders_integration/cornerstone.php');

// elementor integration
include_once(NB_DIR . '/builders_integration/elementor.php');







////////////
// DOCUMENTATION'S LINK
function nb_doc_link($links, $file) {
	if($file == plugin_basename(__FILE__)) {	
		$links['lc_doc_link'] = '<a href="https://doc.lcweb.it/swift_box_wp" target="_blank">'. __('Documentation', 'nb_ml') .'</a>';
	}
	
	return $links;
}
add_filter('plugin_row_meta', 'nb_doc_link', 50, 2);
////////////




////////////
// AUTO UPDATE DELIVER
include_once(NB_DIR . '/classes/lc_plugin_auto_updater.php');
function nb_auto_updates() {
	if(!get_option('nb_no_auto_upd')) {
		$upd = new lc_wp_autoupdate(__FILE__, 'http://updates.lcweb.it', 'lc_updates', 'nb_init_custom_css');
	}
}
add_action('admin_init', 'nb_auto_updates', 1);
////////////










//////////////////////////////////////////////////
// ACTIONS ON PLUGIN ACTIVATION
function nb_init_custom_css() {
	include_once(NB_DIR . '/functions.php');
	
	// if enabled - create custom theme
	if(get_option('nb_custom_style')) {
		if(!nb_create_custom_theme()) {
			if(!get_option('nb_inline_css')) {update_option('nb_inline_css', 1);}
		}
		else {delete_option('nb_inline_css');}
	}
}
register_activation_hook(__FILE__, 'nb_init_custom_css');








//////////////////////////////////////////////////
// REMOVE WP HELPER FROM PLUGIN PAGES

function nb_remove_wp_helper() {
	$cs = get_current_screen();
	$hooked = array('swift-news_page_nb_settings', 'toplevel_page_nb_menu');
	
	if(is_object($cs) && in_array($cs->base, $hooked)) {
		echo '
		<style type="text/css">
		#screen-meta-links {display: none;}
		</style>';	
	}
	
	//var_dump(get_current_screen()); // debug
}
add_action('admin_head', 'nb_remove_wp_helper', 999);
